﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace OmapInterface
{
    public partial class Form1 : Form
    {
        OMapApiRealize g_omapApi = new OMapApiRealize();
        int left=0, buttom=0;
        public struct Rect
        {
            public int Left;
            public int Top;
            public int Right;
            public int Bottom;
        }
        private const int GWL_STYLE = -16;
        private const int WS_CHILD = 0x40000000;
        [DllImport("user32.dll", EntryPoint = "SetParent")]
        public static extern int SetParent(IntPtr hWndChild, IntPtr hWndNewParent);

        [DllImport("user32.dll", EntryPoint = "GetWindowLong")]
        public static extern int GetWindowLong(IntPtr hwnd, int nIndex);

        [DllImport("user32.dll", EntryPoint = "SetWindowLong")]
        public static extern int SetWindowLong(IntPtr hwnd, int nIndex, int dwNewLong);

        [DllImport("user32.dll")]
        private static extern int GetWindowRect(IntPtr hwnd, out  Rect lpRect);
        [DllImport("user32.dll", EntryPoint = "FindWindow")]
        private extern static IntPtr FindWindow(string lpClassName, string lpWindowName);
       
       
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern int SetWindowPos(IntPtr hwnd,int hWndInsertAfter, int x, int y, int Width, int Height, uint flags);
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern System.IntPtr GetForegroundWindow();
         [DllImport("user32", EntryPoint = "ClientToScreen")]
        public static extern int ClientToScreen(
                IntPtr hwnd,
                ref Rect lpPoint
        );
        
        public Form1()
        {
            InitializeComponent();

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            IntPtr hwnd = FindWindow("omapWin", null);
            if (hwnd == IntPtr.Zero)
                this.Close();
            else
            {

                
                Rect rec = new Rect();
                GetWindowRect(hwnd, out rec);
               
                this.Left = rec.Left + 7;
                this.Top = rec.Bottom - 110;
                
                this.StartPosition = FormStartPosition.Manual;
                //this.ShowInTaskbar = false;
                
                
                
            }
            
           
        }

        private void button1_Click(object sender, EventArgs e)
        {

            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

            IntPtr hwnd = FindWindow("omapWin", null);
            Rect rec = new Rect();
            if (hwnd == IntPtr.Zero)
                this.Close();
            else
            {
                GetWindowRect(hwnd, out rec);
                if ((left == 0 && buttom == 0) || left != rec.Left || buttom != rec.Bottom)
                {
                    left = rec.Left;
                    buttom = rec.Bottom;
                    Form1_Load(sender, e);
                }
            }
             
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //此处实现
            
        }
    }
}
